﻿using System;
using System.IO;

using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 소스 디렉토리 경로
        /// </summary>
        private string sourceDirectoryPath = "D:\\ARCA.HOME";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.executeButton.Click += executeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 실행 버튼 클릭시 처리하기 - executeButton_Click(sender, e)

        /// <summary>
        /// 실행 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void executeButton_Click(object sender, EventArgs e)
        {
            this.messageLabelControl.Text = string.Empty;

            this.messageLabelControl.Update();

            this.progressBarControl.Position = this.progressBarControl.Properties.Minimum;

            this.progressBarControl.Update();

            string[] filePathArray = Directory.GetFiles(this.sourceDirectoryPath, "*.*", SearchOption.AllDirectories);

            this.progressBarControl.Properties.Step        = 1;
            this.progressBarControl.Properties.PercentView = true;
            this.progressBarControl.Properties.Maximum     = filePathArray.Length;
            this.progressBarControl.Properties.Minimum     = 0;

            foreach(string filePath in filePathArray)
            {
                this.messageLabelControl.Text = filePath;

                this.messageLabelControl.Update();

                this.progressBarControl.PerformStep();

                this.progressBarControl.Update();
            }
        }

        #endregion
    }
}